import java.awt.Graphics;
import java.util.*;
import java.io.*;

/**
 * Nopat ovat pelikentll sarakkeissa.
 */
public class Column implements Serializable{
    // X-koordinaatti
    private float x;

    // Noppalista
    private List<Die> listOfDice = new ArrayList<Die>();
    
    /**
     * Luo n-korkuisen sarakkeen
     * @param x sarakkeen x-koordinaatti
     * @param n sarakkeen korkeus
     */
    public Column (int x, int n) {
	this.x = x;

	Random r = new Random();
	int random;

	// Alustaa noppalistan satunnaisilla (mutta painotetuilla) nopilla
	for (int i=0,y=0; i<n; i++,y++) {
	    int value = 0;
	    random = r.nextInt(100);
	    if (random == 99)
		value = 7;
	    else if (random <= 27)
		value = 1;
	    else if (random <= 51)
		value = 2;
	    else if (random <= 70)
		value = 3;
	    else if (random <= 85)
		value = 4;
	    else if (random <= 94)
		value = 5;
	    else
		value = 6;
	    
	    listOfDice.add(new Die(y, value));
	}
    }

    /**
     * Luo tyhjn sarakkeen
     * @param x sarakkeen x-koordinaatti
     * @param n sarakkeen korkeus
     * @param z turha
     */
    public Column (int x, int n, int z) {
	this.x = x;

	Random r = new Random();

	// Alustaa noppalistan "tyhjill" nopilla
	for (int i=0; i<n; i++) {
	    int y = 0, value = 0;

	    listOfDice.add(new Die(y, 0));
	}
    }

    /**
     * Palauttaa nopan
     * @param y nopan looginen y-koordinaatti
     */
    public Die getDie(int y) {
	return listOfDice.get(y);
    }

    /**
     * Poistaa nopan
     * @param y poistettavan nopan looginen y-koordinaatti
     */
    public void removeDie(int y) {
	listOfDice.remove(y);
	listOfDice.add(0, new Die(y, 0));
    }

    /**
     * Muuttaa sarakkeen x-koordinaattia animointia varten
     * @param x x-koordinaatti, jota kohti sarake siirtyy
     */
    public void animateTo(float x) {
        if( Math.abs(this.x - x) < 0.1f ) {
            this.x = x;
        }
        else if(this.x < x) {
            this.x += 0.1f;
        }
        else if(this.x > x) {
            this.x -= 0.1f;
        }
    }
    
    /**
     * Palauttaa sarakkeen x-koordinaatin
     * @return sarakkeen x-koordinaatti
     */
    public float getX() {
        return x;
    }

    /**
     * Piirt sarakkeen
     * @param g Graphics-objekti piirtoa varten
     * @param r Resource-instanssi, josta noppien kuvat ja niiden koot haetaan
     * @param imageObserver objekti, jolle ilmoitetaan kuvan piirtmisen edistymisest
     */
    public void draw(Graphics g, Resource r, Game imageObserver)
    {     
        for(int j=0; j < listOfDice.size(); j++) {
            Die d = getDie(j);
            d.animateTo(j);
            d.draw(x, g, r, imageObserver);
        }   
    }
}
