public class Main {

    public final static int StateStartGUI = 0;
    public final static int StateWaitGUI = 1;
    public final static int StateLoading = 2;
    public final static int StateGame = 3;
	
    /** 
     * Luo uuden instanssin Mainista
     */
    public Main() {
    }
    
    /**
     * Pohjelma
     */
    public static void main(String args[]) {

	Draw window = new Draw();
	Resource resource = new Resource();
	
	int state = StateStartGUI;
	    
	while(true)
	{
	    switch( state ) {
	        case StateStartGUI: 
		    (new StartScreen()).run(resource); // show the GUI
		    state = StateWaitGUI;
		    break;
	    
	        case StateWaitGUI:
		    if(resource.isSetupDone()) {  // wait user options
		        state = StateLoading;
		    }
		    break;
		
	        case StateLoading:
		    window.Open(resource);    //level size
		    resource.Load();
		    window.setVisible(true);
		    state = StateGame;
		    break;
		
	        case StateGame:
		    window.repaint();
		    break;
	    }
	
	    try { Thread.sleep(50); } catch (Exception e) {}
	}
    }       
    
}
