import java.net.*;
import java.io.*;

/**
 * Luoka joka synkronoi paikallisen pelaajan ja etpelaajan siirrot ja lhett niist tiedot kummallekin osapuolelle
 */
public class Server {
	
	// Tiedot pelikentst		
	private GameData game;
	
	// socketServer joka hoitaa yhteyden etpelaajaan
	private socketServer eta;
	
	// Yhteys paikalliseen pelaajaan hoidetaan serverManager-olion kautta
	private serverManager lahi;
	
	 /**
     	 * Luo server-olion joka ei viel tied paikallisesta tai etpelaajasta mitn
    	 * @param x Pelikentn tiedot
    	 */
	public Server(GameData x){
		game=x;
		eta=null;
		lahi=null;
	}
	
	/**
	* Asettaa etpelaajaan yhteyden hoitavan socketServer-olion
	*/
	public void setRemote(socketServer x){
		eta=x;
	}
	
	/**
	* Asettaa paikallisen pelaajan kanssa kommunikoivan serverManager-olion
	*/
	public void setLocal(serverManager x){
		lahi=x;
	}
		
		
	/**
	* Jos etpelaaja katkaisee yhteyden, ilmoittaa siit paikalliselle pelaajalle
	*/
	public void bye(int x){
		if(x==1) lahi.otherLeft();
	}
	
	/**
	* Toinen pelaajista valitsee nopan (x,y), kerrotaan molemmille pelaajille valinnasta
	* @param player Pelaaja, joka valinnan tekee
	* @param x Nopan x-koordinaatti
	* @param y Nopan y-koordinaatti
	*/
	public void selectDie(int player,int x,int y) {
		
		// send info to remote player
		try{
		eta.transmit(new Packet("selectDie",player,x,y,null));
		}
		catch (IOException e){
			//System.out.println(e);
		}
		// send info to local player
		lahi.dieSelected(player,x,y);
	}
	
	/**
	* Pelaaja x on saanut summaksi 7 ja haluaa poistaa valitut nopat, ilmoitetaan tst molemmille pelaajille
	* @param x Pelaajan numero, joka haluaa poistaa nopat
	*/
	public void removeMine(int x) {
		//remove the selected dies of player x
		//update scores etc.
		try{
		eta.transmit(new Packet("removeDice",x,0,0,null));
		}
		catch (IOException e){
			//System.out.println(e);
		}
		lahi.diceRemoved(x);
		
	}
	
	/**
	* Pelaaja x haluaa pelikentn datan, lhetetn se hnelle
	* @param x Pyynnn tehneen pelaajan numero
	*/
	public void getGameData(int x) {
		if(x==1){
			try {
				eta.transmit(new Packet("GameData",0,0,0,game));
			}
			catch (IOException e){
				//System.out.println(e);
			}
		}
		else lahi.gotGameData(game);
	}
	
	
}