/**
 * serverManager - toimii yhdyssiteen pelilogiikan ja vastapelaajan vlill
 */

public class serverManager{
	// Tieto toimiiko oma pelaaja palvelimena
	private boolean isHost;
	
	// Osoitin Game-olioon jolle haluamme lhett vastustajan siirrot
	private Game peli;
	
	// socketClient-olio jolle lhetmme viestit jos olemme asiakas
	private socketClient net=null;
	
	// Server-olio jolle lhetmme viestit jos olemme isnt
	private Server servo=null;
	
	
     /**
     * Construktori, joka alustaa olion tarvitsemat muuttujat
     * @param ishost Tieto olemmeko palvelin
     * @param peli Viittaus kutsuvaan Game-olioon
     */
	public serverManager(boolean ishost,Game peli){
		isHost=ishost;
		this.peli=peli;
		}
		
		
	/**
     	* Asettaa socketClientin
     	* @param x socketClient-olio, jonka kautta yhteydenpito hoidetaan
     	*/
	public void setNet(socketClient x){
		net=x;
	}
	
	
	/**
     	* Asettaa Server instanssin
     	* @param x Paikallinen Server-olio, johon ollaan yhteydess
     	*/
	public void setServ(Server x){
		servo=x;
	}
	
	/**
     	* Pyyt pelikentn datan palvelimelta (pelin aluksi)
      	*/
	public void getGameData(){
		if(isHost) servo.getGameData(1);
		else net.getGameData();
	}
	
	
	/**
     	* Pyyt valitsemaan nopan (x,y)
     	* @param x Valittavan nopan x-koordinaatti
     	* @param y Valittavan nopan y-koordinaatti
      	*/
	public void pickDie(int x,int y){
		if(isHost) servo.selectDie(0,x,y);
		else net.selectDie(x,y);
	}
	
	
	/**
     	* Pyyt palvelinta poistamaan omat valitut nopat laudalta(olemme saaneet summaksi 7)
      	*/
	public void removeMine(){
		if(isHost) servo.removeMine(0);
		else net.removeMine();
	}
	
	
	/**
     	* Saimme serverilt tiedon, ett yhteys etpelaajaan on katkennut
     	* toimitetaan se eteenpin
      	*/
	public void otherLeft(){
		//remote player disconnected, do something
		System.out.println("Remote player disconnected(SM)");
	}
	
	/**
     	* Saimme palvelimelta tiedon ett pelaaja player on klikannut noppaa (xy)
     	* Vlitmme tiedon eteenpin kutsumalla Game-luokan dieSelected-metodia
     	* @param player Pelaaja joka valitsi nopan
     	* @param x Valitun nopan x-koordinaatti
     	* @param y Valitun nopan y-koordinaatti
      	*/
	public void dieSelected(int player,int x,int y){
		
		peli.dieSelected(x,y,player);
		
	}
	
	/**
	* Tieto palvelimelta, ett pelaajan player valittuina olevat nopat tulee poistaa pelilaudalta
	* @param player Pelaaja, jonka nopat poistetaan
	*/
	public void diceRemoved(int player){
		
		peli.removeDice(player);
		
	}
	
	/**
	* Jos serveri kertoo ett pisteet ovat muuttuneet lhet tieto eteenpin Game-oliolle
	* @param g GameData olio, joka sislt tiedon pelitilanteesta, mukaanlukien pisteet
	*/
	public void updateScores(GameData g){
		//if this method is needed, then do it
	}
	
	
	/**
	* Serveri on lhettnyt meille pelilaudan tiedot, jos olemme asiakas, pivitetn tiedot Game-olioomme, muuten ei tehd mitn
	* @param g GameData-olio, joka sislt pelikentn tiedot
	*/
	public void gotGameData(GameData g){
		if(!isHost) peli.setGameData(g);
		
	}
	
}