import java.io.*;
import java.net.*;

/**
* Luokka joka hoitaa verkon yli kommunikoinnin asiakkaan pss
*/
public class socketClient implements Runnable{

	// socket, jonka yli kommunikointi tapahtuu
	private Socket kkSocket = null;
	
	// writer, jolla kirjoitetaan sockettiin
	private PrintWriter out = null;
	
	// objektivirta jolla kapseloidaan sockettiin tuleva data
        private	ObjectInputStream in = null;
        
        // si, joka huolehtii tiedon vastaanottamisesta socketista
        private Thread clientThread=null;
        
        // serverManager, jolle lhetetn serverilt saatu data
	private serverManager lahi=null;
	
	// vliaikainen varasta pelidatalle jota siirretn asiakkaan ja palvelimen vlill
	private GameData game;
	
	/**
	* Konstruktori ei ota mitn parametreja
	*/
	public socketClient(){
	}
	
	/**
	* Metodi, joka asettaa rajapinnan pelilogiikkaan pin
	* @param x Pelilogiikkaan liittyv serverManager olio
	*/
	public void setLocal(serverManager x){
		lahi=x;
	}
	
	/**
	* Lhett serverille viestin lhett pelikentn data 
	*/
	public void getGameData(){
		out.println("GetAll");
	}
	
	/**
	* Lhett serverille tiedon ett pelaaja on klikannut noppaa (x,y)
	* @param x Valitun nopan x-koordinaatti
	* @param y Valitun nopan y-koordinaatti
	*/
	public void selectDie(int x,int y){
		String X,Y;
		if(x<10) X="0"+String.valueOf(x);
		else X=String.valueOf(x);
		if(y<10) Y="0"+String.valueOf(y);
		else Y=String.valueOf(y);
		out.println("select:"+X+"->"+Y);
				
	}
	
	/**
	* Lhett palvelimelle pyynnn poistaa paikallisen pelaajan valitsemat nopat
	*/
	public void removeMine(){
		out.println("removemine");
		
		
	}
	
	/**
	* Ottaa yhteyden annettuun osoitteeseen ja porttiin ja kynnist sikeen joka ksittelee palvelimelta tulevan datan
	* @param address Palvelimen ip/url
	* @param port Palvelimen portti
	*/
	public void connect(String address, int port){
		System.out.println("Trying to connect....");
        	try {        		
		kkSocket = new Socket(address,port);
		out = new PrintWriter(kkSocket.getOutputStream(), true);
		in = new ObjectInputStream(
                            kkSocket.getInputStream());
                }
                catch (UnknownHostException e) {
            		System.err.println("Can't find host: "+address);
            		System.exit(1);
        	}
        	catch (IOException e) {
            		System.err.println("Couldn't get I/O for the connection to: "+address);
            		System.exit(1);
        	}
                System.out.println("Connected to the server.");
                clientThread=new Thread(this,"ClientThread");
                clientThread.start();
                
        }
	
	/**
	* Sie, joka ottaa vastaan palvelimelta tulevan datan ja lhett sen eteenpin servermanageriin
	*/
	public void run(){
		System.out.println("Client loop running");
		Packet apu=null;
		try{
		apu=(Packet)in.readObject();
		}
		catch (IOException e){
			//System.out.println(e);
			System.out.println("eka");
		}
		catch (ClassNotFoundException e){
			System.out.println("Received invalid packet");
			System.out.println(e);
		}
		while(!apu.header.equals("Bye!")){
		if(apu.header.equals("GameData")){
			lahi.gotGameData((GameData)apu.data4);
		}
		else if(apu.header.equals("selectDie")){
			if(apu.data1==0) lahi.dieSelected(1,apu.data2,apu.data3);
			else lahi.dieSelected(0,apu.data2,apu.data3);
			
		}
		else if(apu.header.equals("removeDice")){
			if(apu.data1==0) lahi.diceRemoved(1);
			else lahi.diceRemoved(0);
			
		}
		else {
		}
		try{
		apu=(Packet)in.readObject();
		}
		catch (IOException e){
			//System.out.println(e);
			//System.out.println("vika");
		}
		catch (ClassNotFoundException e){
			System.out.println(e);
		}
		}
		System.out.println("ran out of run loop");
		disconnect();
	}
			
		
	
	/**
	* Katkaisee yhteyden palvelimelle 
	*/
	public void disconnect(){
		try{
		out.println("Bye!");
		out.close();
                in.close();
                kkSocket.close();
        	}
        	catch (IOException e){
        		System.out.println(e);
        	}
                System.out.println("Disconnected.");
        }
	
	
}
		
		
		