import java.net.*;
import java.io.*;

/**
* Luokka, joka ksittelee verkon yli tapahtuvan kommunikaation palvelimen pss
*/
public class socketServer implements Runnable{

	// portti, jota kuunnellaan
	private int port;
	
	// Server-olio jolle lhetetn saadut pyynnt
	private Server server;
	
	// onko yhteys asiakkaaseen saatu
	private boolean clientConnected;
	
	// sie joka kuuntelee asiakkaan viestej socketista
	private Thread serverThread;
	
	// palvelin socket
	private ServerSocket servSocket = null;
	
	// asiakas socket
	private Socket clientSocket = null;
	
	// kapselointi datan lhettmist varten
	private ObjectOutputStream out;
	
	// kapselointi datan vastaanottamista varten
	private BufferedReader in;
	
	// vliaikais varasta pelikentn tiedoille
	private GameData game;
	
	// onko yhteys katkennut?
	private boolean dc=false;
	
	
	/**
	* Konstruktori
	* @param port Portti jota kuunnellaan
	* @param server Palvelin jolle pyynnt vlitetn
	*/
	public socketServer(int port,Server server){
		this.port=port;
		this.server=server;
		clientConnected=false;
		
	}
	
	
	/**
	* Avaa socketin mriteltyyn porttiin ja j odottaamaan asiakkaan yhteydenottoa
	* Kun asiakas saadaan kynnist sikeen joka vastaanottaa asiakkaan pyynnt
	*/
	public void getClient(){
		System.out.println("Trying to open port "+port+" for incoming traffic...");
		try {
    		servSocket = new ServerSocket(port);
		} catch (IOException e) {
    		System.out.println("Could not listen on port: "+port);
    		System.exit(-1);
		}
		System.out.println("Waiting for a client to connect....");
		try {
    		clientSocket = servSocket.accept();
		} catch (IOException e) {
    		System.out.println("Handshake failed.");
    		System.exit(-1);
		}
		clientConnected=true;
		System.out.println("Client connected");
		serverThread=new Thread(this,"ServerThread");
		serverThread.start();
	}
	
	/**
	* Palauttaa tiedon onko asiakas yhteydess
	* @return boolean True jos asiakas on yhteydess, false muuten
	*/
	public boolean connected(){
		return clientConnected;
	}
	
	/**
	* Vastaanottaa asiakkaan lhettmt pyynnt ja ohjaa ne edelleen Server-oliolle
	*/
	public void run() {
		try {
		out = new ObjectOutputStream(clientSocket.getOutputStream());
		in = new BufferedReader(new InputStreamReader(
		clientSocket.getInputStream()));
		}
		catch (IOException e){
			System.out.println(e);
		}
		String inputLine="";
		try {
		inputLine=in.readLine();
		}
		catch (IOException e){
			//System.out.println(e);
		}
		
		while(!inputLine.equals("Bye!")){
			System.out.println("Inputline:"+inputLine);
			if(inputLine.indexOf("GetAll")!=-1){
				server.getGameData(1);
				
			}
			else if(inputLine.indexOf("select:")!=-1){
				int x = Integer.parseInt(inputLine.substring(7,9));
				int y = Integer.parseInt(inputLine.substring(11));
				server.selectDie(1,x,y);
			}
			else if(inputLine.indexOf("removemine")!=-1){
				server.removeMine(1);
			}
			else {
				}
			
			try {
			out.reset();		
			inputLine=in.readLine();
			}
			catch (IOException e){
				//System.out.println(e);
				System.out.println("Remote client was disconnected...");
				inputLine="Bye!";
			}
		}
		server.bye(1);
		try{
		transmit(new Packet("Bye!",0,0,0,null));
		out.close();
		in.close();
		clientSocket.close();
		}
		catch (IOException e){
			
			//System.out.println(e);
		}
		
	}
	
	/**
	* Katkaisee yhteyden asiakkaaseen
	*/
	public void disconnect() {
		try{
		clientSocket.close();
		servSocket.close();
		}
		catch (IOException e){
			System.out.println(e);
		}
		System.out.println("The client disconnected.");
	}
	
	
	/**
	* Vlitt paketin x etasiakkaalle
	* @param x Packet-luokan olio joka lhetetn asiakkaalle
	*/
	public void transmit(Packet x) throws IOException{
		out.writeObject(x);
		
	}
			
	
	
		
			
	
}